replace = [
["KC_LCTRL", "KC_LCTL"],
["KC_RCTRL", "KC_RCTL"],
["KC_LSHIFT", "KC_LSFT"],
["KC_RSHIFT", "KC_RSFT"],
["KC_RIGHT", "KC_RGHT"],
["_______", "KC_TRNS"],
["XXXXXXX", "KC_NO"],
["KC_KP_DOT", "KC_PDOT"],
["KC_KP_0", "KC_P0"],
["KC_KP_1", "KC_P1"],
["KC_KP_2", "KC_P2"],
["KC_KP_3", "KC_P3"],
["KC_KP_4", "KC_P4"],
["KC_KP_5", "KC_P5"],
["KC_KP_6", "KC_P6"],
["KC_KP_7", "KC_P7"],
["KC_KP_8", "KC_P8"],
["KC_KP_9", "KC_P9"],
["KC_KP_ENTER", "KC_PENT"],
["KC_KP_PLUS", "KC_PPLS"],
["KC_KP_MINUS", "KC_PMNS"],
["KC_KP_ASTERISK", "KC_PAST"],
["KC_KP_SLASH", "KC_PSLS"],
["KC_NUMLOCK", "KC_NLCK"],
["KC_AUDIO_MUTE","KC_MUTE"],
["KC_AUDIO_VOL_UP", "KC_VOLU"],
["KC_AUDIO_VOL_DOWN", "KC_VOLD"],
["KC_MEDIA_NEXT_TRACK", "KC_MNXT"],
["KC_MEDIA_PREV_TRACK", "KC_MPRV"],
["KC_MEDIA_STOP", "KC_MSTP"],
["KC_MEDIA_PLAY_PAUSE", "KC_MPLY"],
["KC_MEDIA_SELECT", "KC_MSEL"],
["KC_MEDIA_EJECT", "KC_EJCT"],
["EEPROM_RESET", "EEP_RST"],
["KC_NONUS_BSLASH", "KC_NUBS"],
["KC_NONUS_HASH", "KC_NUHS"],
["KC_INT1", "KC_RO"],
]

import os, re, sys, subprocess

d = open("keymap.c").read()

layernames = [i.strip() for i in d.split("layer_names", 1)[1].split("{", 1)[1].split("}", 1)[0].split(",")]
layernames = [i for i in layernames if i]
#print layernames

for i in replace:
    d = d.replace(i[0], i[1])
for i in range(len(layernames)):
    #print layernames[i], str(i)
    d = re.sub("\\b"+layernames[i]+"\\b", str(i), d)

cwd = os.getcwd()
kb = cwd.split("/keymaps")[-2].split("/keyboards/")[-1]

comm = subprocess.check_output(["git", "rev-parse", "HEAD"]).strip()

lay = (re.search(r"(LAYOUT[a-zA-Z0-9_]*)\(", d).groups()[0])

dd = d.split(lay + "(")[1:]
#print dd
for i in range(len(dd)):
    cnt = 0
    for j in range(len(dd[i])):
        if dd[i][j] == "(":
            cnt+=1
        if dd[i][j] == ")":
            cnt-=1
            if cnt < 0:
                dd[i] = dd[i][:j]
                break
    dd[i] = [x.strip() for x in dd[i].split("\n")]
    dd[i] = [x[:-1].strip() if x.endswith("\\") else x for x in dd[i]]
    dd[i] = "\n".join(["      " + re.sub("([A-Za-z0-9_\(\)]+)", r'"\1"', x) for x in dd[i] if x])
    if i<len(dd)-1:
        dd[i] = "    [\n" + dd[i] + "\n    ],\n"
    else:
        dd[i] = "    [\n" + dd[i] + "\n    ]\n"

sys.stdout.write(
"""{
  "keyboard": "%s",
  "keymap": "default_%s",
  "commit": "%s",
  "layout": "%s",
  "layers": [
""" % (kb, comm[:7], comm, lay))
sys.stdout.write("".join(dd))
sys.stdout.write("  ]\n}\n")

